
	DynUnicoWS_Init PROTO 
	DynUnicoWS_RebildImports PROTO hModule:DWORD

.CONST
	DynUnicoWS_DEBUG=1

.DATA?
	g_pdwOrd	DWORD ?
	g_pdwNames	DWORD ?
	g_pdwAddrs	DWORD ?
	g_dwNames	DWORD ?
.DATA
	g_hModuleUnicows DWORD 0

	TEXT_Unicows_dll DB 'Unicows.dll',0
.CODE
;_________________________________________________________
DynUnicoWS_Init PROC USES EBX ESI EDI	;IN ORI NAME IS: _UnicowsInit
;	LOCAL pDosHeader:DWORD	;ORI:PIMAGE_DOS_HEADER
	LOCAL pNTHeaders:DWORD	;ORI:PIMAGE_NT_HEADERS
;	LOCAL expDir:IMAGE_DATA_DIRECTORY
	LOCAL pExpDir:DWORD	;ORI:IMAGE_EXPORT_DIRECTORY

	 MOV g_hModuleUnicows,FUNC(LoadLibraryA,ADDR TEXT_Unicows_dll)
	 .IF EAX==FALSE
	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('LoadLibrary')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF

;		  	/	Find export table
;	 PIMAGE_DOS_HEADER pDosHeader = PIMAGE_DOS_HEADER(g_hModuleUnicows);
	 Invoke IsBadReadPtr,g_hModuleUnicows,sizeof(IMAGE_DOS_HEADER)
	 .IF(AX!=0)
	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('IsBadReadPtr, g_hModuleUnicows')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF
	 XOR EAX,EAX
	 MOV EBX,[g_hModuleUnicows]
	 MOV AX,(IMAGE_DOS_HEADER PTR [EBX]).e_magic
	 .IF AX!=IMAGE_DOS_SIGNATURE
	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('AX!=IMAGE_DOS_SIGNATURE')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF

;    PIMAGE_NT_HEADERS pNTHeaders = MakePtr(PIMAGE_NT_HEADERS, g_hModuleUnicows, pDosHeader->e_lfanew);
;	 LEA EAX,(IMAGE_DOS_HEADER PTR [EBX]).e_lfanew; this is wrong
;NOP
;NOP
	 MOV EAX,(IMAGE_DOS_HEADER PTR [EBX]).e_lfanew
	 ADD EAX,EBX
	 MOV pNTHeaders,EAX
;    if (::IsBadReadPtr(pNTHeaders, sizeof(IMAGE_NT_HEADERS))
;            || IMAGE_NT_SIGNATURE != pNTHeaders->Signature)
;        return ::SetLastError(ERROR_INVALID_PARAMETER), FALSE;
	 .IF FUNC(IsBadReadPtr,pNTHeaders,sizeof(IMAGE_NT_HEADERS))!=0
	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('IsBadReadPtr,pNTHeaders')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF
;NOP
;NOP
;	 MOV EBX,pNTHeaders
;	 MOV EBX,(IMAGE_DOS_HEADER PTR [EBX]).e_lfanew
;	 MOV EAX,(IMAGE_NT_HEADERS PTR [EBX]).Signature
	 MOV EAX,pNTHeaders
;	 ADD EAX,0Fh
	 MOV EAX,[EAX]
	 .IF EAX!=IMAGE_NT_SIGNATURE
	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('EAX!=IMAGE_NT_SIGNATURE')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF

;nop
;nop
;	 IMAGE_DATA_DIRECTORY& expDir = pNTHeaders->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT];
;	 PIMAGE_EXPORT_DIRECTORY pExpDir = MakePtr(PIMAGE_EXPORT_DIRECTORY, g_hModuleUnicows, expDir.VirtualAddress);
	 MOV	EAX,pNTHeaders
	 MOV	ECX,DWORD PTR(IMAGE_NT_HEADERS PTR [EAX]).OptionalHeader.DataDirectory
	 ADD	ECX,EBX
	 MOV	pExpDir,ECX

;    //     
;    g_pdwOrd = MakePtr(LPWORD, g_hModuleUnicows, pExpDir->AddressOfNameOrdinals);
;    g_pdwNames = MakePtr(LPDWORD, g_hModuleUnicows, pExpDir->AddressOfNames);
;    g_pdwAddrs = MakePtr(LPDWORD, g_hModuleUnicows, pExpDir->AddressOfFunctions);
;    g_dwNames = pExpDir->NumberOfNames;

	 MOV	EAX,(IMAGE_EXPORT_DIRECTORY PTR[ECX]).AddressOfNameOrdinals
	 ADD	EAX,EBX
	 MOV	g_pdwOrd,EAX

	 MOV	EAX,(IMAGE_EXPORT_DIRECTORY PTR[ECX]).AddressOfNames
	 ADD	EAX,EBX
	 MOV	g_pdwNames,EAX

	 MOV	EAX,(IMAGE_EXPORT_DIRECTORY PTR[ECX]).AddressOfFunctions
	 ADD	EAX,EBX
	 MOV	g_pdwAddrs,EAX

	 MOV	EAX,(IMAGE_EXPORT_DIRECTORY PTR[ECX]).NumberOfNames
	 MOV	g_dwNames,EAX

	MOV EAX,TRUE
ProcExit:
 RET
DynUnicoWS_Init ENDP
;______________________________________________________________________________
;static LPWORD   g_pdwOrd = NULL;
;static LPDWORD  g_pdwAddrs = NULL;
;static LPDWORD  g_pdwNames = NULL;
;static DWORD    g_dwNames = 0;
;static LPDWORD GetFunctionAddress(LPCSTR azName)
;{
;    for (DWORD dwName = 0; dwName < g_dwNames; dwName++)
;    {
;        if (0 == ::lstrcmpiA(MakePtr(LPSTR, g_hModuleUnicows, g_pdwNames[dwName]), azName))
;            return MakePtr(LPDWORD, g_hModuleUnicows, g_pdwAddrs[g_pdwOrd[dwName]]);
;    }
;
;    return NULL;
;}
DynUnicoWS_GetFunctionAddress PROC USES EBX ESI EDI azName:DWORD
;	LOCAL dwName:DWORD
	 XOR EBX,EBX
@Begin_loop:
;nop
;nop
	 MOV ESI,g_pdwNames
	 MOV EAX,4
	 MUL EBX
	 ADD ESI,EAX
	 MOV ESI,[ESI]
	 ADD ESI,g_hModuleUnicows
	 .IF FUNC(lstrcmpiA,ESI,azName)==0
;	  MOV EAX,ESI
;INT 3;DEBUG
	  MOV ESI,g_pdwOrd
	  MOV EAX,2
	  MOV ECX,EBX
	  INC ECX
	  MUL ECX
;	  MOV EAX,EBX
;	  ADD EAX,1;nBase for "UnicoWS.DLL"
	  ADD ESI,EAX
	  XOR ECX,ECX
	  MOV CX,[ESI]
	  DEC CX
;NOW:  In ECX 16-bit number
;nop
	  MOV EAX,4
	  MUL ECX
;	  MOV ECX,g_pdwAddrs
	  ADD EAX,g_pdwAddrs
	  MOV EAX,[EAX]
	  ADD EAX,g_hModuleUnicows
;	  nop
	  JMP @ExitProc
	 .ENDIF
	 INC EBX
	 CMP EBX,g_dwNames
	 JL @Begin_loop
 XOR EAX,EAX
@ExitProc:
 RET
DynUnicoWS_GetFunctionAddress ENDP
;______________________________________________________________________________
DynUnicoWS_RebildImports PROC USES EBX ESI EDI hModule:DWORD;IN ORI NAME IS: _UnicowsRebindImports
	LOCAL pNTHeaders:DWORD
	LOCAL pImpDesc:DWORD	;PIMAGE_IMPORT_DESCRIPTOR
	LOCAL pEnd:DWORD
	LOCAL azFunctionName:DWORD;pChar
	LOCAL dwAddr:DWORD
	LOCAL dwOldProtect:DWORD
;	 PIMAGE_DOS_HEADER pDosHeader = PIMAGE_DOS_HEADER(hModule);
;    if (::IsBadReadPtr(pDosHeader, sizeof(IMAGE_DOS_HEADER))
;            || IMAGE_DOS_SIGNATURE != pDosHeader->e_magic)
;        return ::SetLastError(ERROR_INVALID_PARAMETER), FALSE;
	 .IF FUNC(IsBadReadPtr,hModule,sizeof(IMAGE_DOS_HEADER))!=0
  	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('IsBadReadPtr')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF

	 XOR EAX,EAX
	 MOV EBX,[hModule]
	 MOV AX,(IMAGE_DOS_HEADER PTR [EBX]).e_magic
	 .IF AX!=IMAGE_DOS_SIGNATURE
	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('DynUnicoWS_RebildImports:AX!=IMAGE_DOS_SIGNATURE')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF

;    PIMAGE_NT_HEADERS pNTHeaders = MakePtr(PIMAGE_NT_HEADERS, hModule, pDosHeader->e_lfanew);
	 MOV EAX,(IMAGE_DOS_HEADER PTR [EBX]).e_lfanew
	 ADD EAX,EBX
	 MOV pNTHeaders,EAX

;    if (::IsBadReadPtr(pNTHeaders, sizeof(IMAGE_NT_HEADERS))
;            || IMAGE_NT_SIGNATURE != pNTHeaders->Signature)
;        return ::SetLastError(ERROR_INVALID_PARAMETER), FALSE;
	 .IF FUNC(IsBadReadPtr,pNTHeaders,sizeof(IMAGE_NT_HEADERS))!=0
	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('DynUnicoWS_RebildImports:IsBadReadPtr')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF

	 MOV EAX,pNTHeaders
;	 ADD EAX,0Fh
	 MOV EAX,[EAX]
	 .IF EAX!=IMAGE_NT_SIGNATURE
	  IF DynUnicoWS_DEBUG
	  Invoke FatalAppExitA,0,chr$('DynUnicoWS_RebildImports:EAX!=IMAGE_NT_SIGNATURE')
	  ENDIF
	  XOR EAX,EAX
	  JMP ProcExit
	 .ENDIF

;    IMAGE_DATA_DIRECTORY& impDir = pNTHeaders->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT];
;    PIMAGE_IMPORT_DESCRIPTOR pImpDesc = MakePtr(PIMAGE_IMPORT_DESCRIPTOR, hModule, impDir.VirtualAddress),
;            pEnd = pImpDesc + impDir.Size / sizeof(IMAGE_IMPORT_DESCRIPTOR) - 1;
;nop
;nop
	 MOV	EAX,pNTHeaders
	 MOV	ECX,DWORD PTR(IMAGE_NT_HEADERS PTR[EAX]).OptionalHeader.DataDirectory+IMAGE_DIRECTORY_ENTRY_IMPORT*SizeOf(IMAGE_DATA_DIRECTORY);-SizeOf(IMAGE_DATA_DIRECTORY);ECI=impDir.VirtualAddress
	 MOV	EDX,DWORD PTR(IMAGE_NT_HEADERS PTR[EAX]).OptionalHeader.DataDirectory+IMAGE_DIRECTORY_ENTRY_IMPORT*SizeOf(IMAGE_DATA_DIRECTORY)+4;-SizeOf(IMAGE_DATA_DIRECTORY);EDX=impDir.Size
;nop
;nop

	 MOV EAX,ECX
	 ADD EAX,EBX
	 MOV pImpDesc,EAX

	 MOV EAX,EDX
	 MOV EDX,sizeof(IMAGE_IMPORT_DESCRIPTOR)
	 DIV DL
;	 DEC EAX
	 MOV EDX,sizeof(IMAGE_IMPORT_DESCRIPTOR)
	 MUL DL
	 ADD EAX,pImpDesc; xWe DIV AX (Word)
	 MOV pEnd,EAX
;nop
;nop
	 MOV ESI,pImpDesc
	 .WHILE ESI<pEnd
	  MOV EAX,(IMAGE_IMPORT_DESCRIPTOR PTR [ESI]).OriginalFirstThunk
	  .IF EAX>0
;            PIMAGE_THUNK_DATA pNamesTable = MakePtr(PIMAGE_THUNK_DATA, hModule, pImpDesc->OriginalFirstThunk);
	   MOV EDI,(IMAGE_IMPORT_DESCRIPTOR PTR [ESI]).OriginalFirstThunk
	   ADD EDI,EBX;EBX=hModule	EDI=pNamesTable
nop
;	   .WHILE (IMAGE_THUNK_DATA PTR [EDI]).u1.AddressOfData
	   MOV EAX,(IMAGE_THUNK_DATA PTR [EDI]).u1.AddressOfData
;	   ADD EAX,EBX
;	   .IF EAX!=0
	   .WHILE EAX!=0
nop
nop
	    ;azFunctionName declare
;nop
;	    MOV EAX,(IMAGE_THUNK_DATA PTR [EDI]).u1.Ordinal
;	    .IF EAX==0;(IMAGE_SNAP_BY_ORDINAL(pNamesTable->u1.Ordinal))	IMAGE_ORDINAL_FLAG32
;			   ,  
;	     Invoke FatalAppExitA,0,chr$('So... If you need this  do this!')
;	    .ELSE
;             PIMAGE_IMPORT_BY_NAME pName = MakePtr(PIMAGE_IMPORT_BY_NAME, hModule, pNamesTable->u1.AddressOfData);
;             azFunctionName = LPCSTR(pName->Name);
;nop
;nop
	     MOV	EAX,(IMAGE_THUNK_DATA PTR [EDI]).u1.AddressOfData
	     ADD	EAX,EBX
	     LEA	ECX,(IMAGE_IMPORT_BY_NAME PTR [EAX]).Name1
	     MOV	azFunctionName,ECX
;	    .ENDIF
	    ;dwAddr

	    
	    MOV dwAddr,FUNC(DynUnicoWS_GetFunctionAddress,azFunctionName)
	    .IF EAX!=0
	     PUSH EBX
	     ;     Unicows.dll
;	     Invoke FatalAppExitA,0,chr$('    Unicows.dll')
;    LPDWORD *pProc = MakePtr(LPDWORD *, pNamesTable, pImpDesc->FirstThunk-pImpDesc->OriginalFirstThunk)
	     ;EBX=pProc
	     MOV ECX,pImpDesc
	     MOV EBX,(IMAGE_IMPORT_DESCRIPTOR PTR [ECX]).FirstThunk
	     SUB EBX,(IMAGE_IMPORT_DESCRIPTOR PTR [ECX]).OriginalFirstThunk
	     ADD EBX,EDI
;nop
;                        //  
;                        DWORD dwOldProtect = 0;
;                        if (::VirtualProtect(pProc, sizeof(DWORD), PAGE_READWRITE, &dwOldProtect))
;                        {
;                            *pProc = dwAddr;
;                            //  
;                            ::VirtualProtect(pProc, sizeof(DWORD), dwOldProtect, &dwOldProtect);
;                        }
;comment 
;int 3
	     .IF FUNC(VirtualProtect,EBX,sizeof(DWORD),PAGE_READWRITE,ADDR dwOldProtect)!=0
;NOP
	      MOV EAX,dwAddr
	      MOV DWORD PTR [EBX],EAX
;NOP
	      Invoke VirtualProtect,EBX,sizeof(DWORD),dwOldProtect,ADDR dwOldProtect
	     .ENDIF	;
	     POP EBX
	    .ENDIF
	    ADD EDI,SizeOf(IMAGE_THUNK_DATA)
;	    add esi, sizeof IMAGE_IMPORT_DESCRIPTOR	; next import descriptor
	    MOV EAX,(IMAGE_THUNK_DATA PTR [EDI]).u1.AddressOfData
	   .ENDW
	   
	  .ENDIF
	  ;INC ESI;pImpDesc
	  ADD ESI,sizeof(IMAGE_IMPORT_DESCRIPTOR)
	 .ENDW



ProcExit:
 RET
DynUnicoWS_RebildImports ENDP

